﻿#include "AneuMeshLoader.h"
#include <ranges>
#include <fstream>
#include <algorithm>
#include <iterator>


//!!! Задание на защиту (не удалять)
//!!! Реализовать на основе std::ranges 
//!!! 1. Получить контейнер всех узлов (не ID, Node) с данной грани.
//!!! 2. Отсортировать контейнер по степени близости от заданного узла.
//!!! 3. Вывести в файл за один pipeline координаты 10 узлов, начиная с 5-го.

void Protection_task(MeshLoader& loader) {
	auto ContainerNodes = loader.GetNode();
	double x, y, z;
	std::cout << "Enter the coordinates of the node: " << std::endl;
	std::cout << "\tx: ";
	std::cin >> x;
	std::cout << "\ty: ";
	std::cin >> y;
	std::cout << "\tz: ";
	std::cin >> z;

	auto alg = [&](const auto& elem) { 
		double elem_x = elem.Coordinate.at(0),
			elem_y = elem.Coordinate.at(1),
			elem_z = elem.Coordinate.at(2);
		return sqrt((elem_x - x) * (elem_x - x) + (elem_y - y) * (elem_y - y) + (elem_z - z) * (elem_z - z));
	};
	std::ranges::sort(ContainerNodes, std::less <double>{},[&](const Node& a) {
			return alg(a);
	});
	auto result = ContainerNodes | std::ranges::views::drop(5) | std::ranges::views::take(10);
	
	std::ranges::copy(result, std::ostream_iterator<Node>(std::cout, "\n"));
	
	//!!! В задании сказано вывести в файл координаты узлов, в не сами узлы.
	//!!! Где в pipeline преобразование Node в std::array<double, 3>?

}

int main() {
	std::unique_ptr<MeshLoader> p(new AneuMeshLoader);
	std::string str;
	std::cout << "Enter the file name: ";
	std::cin >> str;
	p->loadMesh(str);
	Protection_task(*p);
	return 0;
}



